/* vsgi-0.3.vapi generated by valac 0.26.1, do not modify. */

[CCode (gir_namespace = "VSGI", gir_version = "0.3")]
namespace VSGI {
	namespace CGI {
		[CCode (cheader_filename = "vsgi.h")]
		[Version (experimental = true)]
		public class Request : VSGI.Request {
			[Version (experimental = true)]
			public Request (VSGI.Connection connection, string[] environment);
			[Version (experimental = true)]
			public string[] environment { get; construct; }
			public override string gateway_interface { owned get; }
			public override Soup.HTTPVersion http_version { get; }
			public override string method { owned get; }
			public override GLib.HashTable<string,string>? query { get; }
			public override Soup.URI uri { get; }
		}
		[CCode (cheader_filename = "vsgi.h")]
		[Version (experimental = true)]
		public class Response : VSGI.Response {
			[Version (experimental = true)]
			public Response (VSGI.CGI.Request request);
			protected override bool write_headers (Soup.MessageHeaders headers, out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
			protected override bool write_status_line (Soup.HTTPVersion http_version, uint status, string reason_phrase, out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
			public override GLib.OutputStream body { get; }
		}
	}
	[CCode (gir_namespace = "VSGI", gir_version = "0.3")]
	namespace CookieUtils {
		[CCode (cheader_filename = "vsgi.h")]
		[Version (since = "0.3")]
		public static void sign (Soup.Cookie cookie, GLib.ChecksumType checksum_type, uint8[] key);
		[CCode (cheader_filename = "vsgi.h")]
		[Version (since = "0.3")]
		public static bool verify (Soup.Cookie cookie, GLib.ChecksumType checksum_type, uint8[] key, out string? value);
	}
	namespace Mock {
		[CCode (cheader_filename = "vsgi.h")]
		[Version (experimental = true)]
		public class Connection : VSGI.Connection {
			[Version (experimental = true)]
			public Connection (VSGI.Mock.Server server);
			[Version (experimental = true)]
			public GLib.MemoryInputStream get_memory_input_stream ();
			[Version (experimental = true)]
			public GLib.MemoryOutputStream get_memory_output_stream ();
			public override GLib.InputStream input_stream { get; }
			public override GLib.OutputStream output_stream { get; }
		}
		[CCode (cheader_filename = "vsgi.h")]
		[Version (experimental = true)]
		public class Request : VSGI.Request {
			[Version (experimental = true)]
			public Request (VSGI.Mock.Connection connection, string method, Soup.URI uri, GLib.HashTable<string,string>? query = null);
			[Version (experimental = true)]
			public Request.with_method (string method, Soup.URI uri, GLib.HashTable<string,string>? query = null);
			[Version (experimental = true)]
			public Request.with_query (GLib.HashTable<string,string>? query);
			[Version (experimental = true)]
			public Request.with_uri (Soup.URI uri, GLib.HashTable<string,string>? query = null);
			public override string gateway_interface { owned get; }
			public override Soup.HTTPVersion http_version { get; }
			public override string method { owned get; }
			public override GLib.HashTable<string,string>? query { get; }
			public override Soup.URI uri { get; }
		}
		[CCode (cheader_filename = "vsgi.h")]
		[Version (experimental = true)]
		public class Response : VSGI.Response {
			[Version (experimental = true)]
			public Response (VSGI.Mock.Request req);
			[Version (experimental = true)]
			public Response.with_status (VSGI.Mock.Request req, uint status);
			protected override bool write_headers (Soup.MessageHeaders headers, out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
			protected override bool write_status_line (Soup.HTTPVersion http_version, uint status, string reason_phrase, out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		}
		[CCode (cheader_filename = "vsgi.h")]
		[Version (experimental = true)]
		public class Server : VSGI.Server {
			public Server ();
			public override void listen (GLib.SocketAddress? address = null) throws GLib.Error;
			public override void listen_socket (GLib.Socket socket) throws GLib.Error;
			public override void stop ();
			public override GLib.SList<Soup.URI> uris { owned get; }
		}
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class Application : GLib.Application {
		[Version (since = "0.3")]
		public Application (VSGI.Server server);
		public override int command_line (GLib.ApplicationCommandLine command_line);
		[Version (since = "0.3")]
		public VSGI.Server server { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public abstract class Authentication : GLib.Object {
		public Authentication ();
		[Version (since = "0.3")]
		public abstract bool parse_authorization_header (string authorization_header, out VSGI.Authorization? authorization);
		[Version (since = "0.3")]
		public abstract string to_authenticate_header ();
		[Version (since = "0.3")]
		public string? charset { get; construct; }
		[Version (since = "0.3")]
		public string realm { get; set construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public abstract class Authorization : GLib.Object {
		public Authorization ();
		[Version (since = "0.3")]
		public abstract bool challenge_with_password (string password);
		[Version (since = "0.3")]
		public abstract string to_authorization_header ();
		[Version (since = "0.3")]
		public string username { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class BasicAuthentication : VSGI.Authentication {
		[Version (since = "0.3")]
		public BasicAuthentication (string realm, string? charset = null);
		public override bool parse_authorization_header (string header, out VSGI.Authorization? authorization);
		public override string to_authenticate_header ();
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class BasicAuthorization : VSGI.Authorization {
		[Version (since = "0.3")]
		public BasicAuthorization (string username, string password);
		public override bool challenge_with_password (string password);
		public override string to_authorization_header ();
		[Version (since = "0.3")]
		public string password { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class BoundedInputStream : GLib.FilterInputStream {
		[Version (since = "0.3")]
		public BoundedInputStream (GLib.InputStream base_stream, int64 content_length);
		public override bool close (GLib.Cancellable? cancellable = null) throws GLib.IOError;
		public override ssize_t read (uint8[] buffer, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public int64 content_length { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public abstract class Connection : GLib.IOStream {
		public Connection ();
		[Version (since = "0.3")]
		public VSGI.Server server { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public abstract class Handler : GLib.Object {
		public Handler ();
		[Version (since = "0.3")]
		public abstract bool handle (VSGI.Request req, VSGI.Response res) throws GLib.Error;
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class HandlerModule : GLib.TypeModule {
		[Version (since = "0.3")]
		public HandlerModule (string? directory, string name);
		public override bool load ();
		public override void unload ();
		[Version (since = "0.3")]
		public string? directory { get; construct; }
		[Version (since = "0.3")]
		public GLib.Type handler_type { get; private set; }
		[Version (since = "0.3")]
		public string name { get; construct; }
		[Version (since = "0.3")]
		public string path { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.1")]
	public abstract class Request : GLib.Object {
		[Version (experimental = true, since = "0.3")]
		protected GLib.InputStream? _body;
		[Version (experimental = true, since = "0.1")]
		public const string CONNECT;
		[Version (experimental = true, since = "0.1")]
		public const string DELETE;
		[Version (experimental = true, since = "0.1")]
		public const string GET;
		[Version (experimental = true, since = "0.1")]
		public const string HEAD;
		[Version (experimental = true, since = "0.1")]
		public const string[] METHODS;
		[Version (experimental = true, since = "0.1")]
		public const string OPTIONS;
		[Version (experimental = true, since = "0.1")]
		public const string PATCH;
		[Version (experimental = true, since = "0.1")]
		public const string POST;
		[Version (experimental = true, since = "0.1")]
		public const string PUT;
		[Version (experimental = true, since = "0.1")]
		public const string TRACE;
		public Request ();
		[Version (since = "0.3")]
		public void convert (GLib.Converter converter, int64 content_length = -1);
		[Version (since = "0.2")]
		public virtual uint8[] flatten (GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.2")]
		public virtual async uint8[] flatten_async (int io_priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.2")]
		public GLib.Bytes flatten_bytes (GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.2")]
		public async GLib.Bytes flatten_bytes_async (int io_priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.2")]
		public string flatten_utf8 (GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.2")]
		public async string flatten_utf8_async (int io_priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public Soup.Cookie? lookup_cookie (string name);
		[Version (since = "0.3")]
		public string? lookup_query (string key);
		[Version (since = "0.3")]
		public Soup.Cookie? lookup_signed_cookie (string name, GLib.ChecksumType checksum_type, uint8[] key, out string? value);
		[Version (since = "0.2")]
		public GLib.InputStream body { get; }
		[Version (since = "0.2")]
		public VSGI.Connection connection { get; construct; }
		[Version (since = "0.3")]
		public GLib.SList<Soup.Cookie> cookies { owned get; }
		[Version (since = "0.3")]
		public abstract string gateway_interface { owned get; }
		[Version (since = "0.1")]
		public Soup.MessageHeaders headers { get; protected set construct; }
		[Version (since = "0.3")]
		public abstract Soup.HTTPVersion http_version { get; }
		[Version (since = "0.1")]
		public abstract string method { owned get; }
		[Version (since = "0.1")]
		public abstract GLib.HashTable<string,string>? query { get; }
		[Version (since = "0.1")]
		public abstract Soup.URI uri { get; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.1")]
	public abstract class Response : GLib.Object {
		[Version (experimental = true, since = "0.3")]
		protected GLib.OutputStream? _body;
		public Response ();
		[Version (since = "0.3")]
		public bool append (uint8[] buffer, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public async bool append_async (uint8[] buffer, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public bool append_bytes (GLib.Bytes buffer, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public async bool append_bytes_async (GLib.Bytes buffer, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public bool append_utf8 (string buffer, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public async bool append_utf8_async (string buffer, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public void convert (GLib.Converter converter, int64 content_length = -1);
		public override void dispose ();
		[Version (since = "0.3")]
		public bool end (GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public async bool end_async (int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public virtual bool expand (uint8[] buffer, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public virtual async bool expand_async (uint8[] buffer, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public bool expand_bytes (GLib.Bytes bytes, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public async bool expand_bytes_async (GLib.Bytes bytes, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public virtual bool expand_file (GLib.File file, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public virtual async bool expand_file_async (GLib.File file, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public virtual bool expand_stream (GLib.InputStream @in, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public virtual async bool expand_stream_async (GLib.InputStream @in, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public bool expand_utf8 (string body, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public async bool expand_utf8_async (string body, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[Version (since = "0.3")]
		public void tee (GLib.OutputStream tee_stream);
		[Version (since = "0.2")]
		public bool write_head (out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public async bool write_head_async (int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null, out size_t bytes_written) throws GLib.Error;
		[Version (since = "0.3")]
		protected abstract bool write_headers (Soup.MessageHeaders headers, out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		protected virtual async bool write_headers_async (Soup.MessageHeaders headers, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null, out size_t bytes_written) throws GLib.Error;
		[Version (since = "0.3")]
		protected abstract bool write_status_line (Soup.HTTPVersion http_version, uint status, string reason_phrase, out size_t bytes_written, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		protected virtual async bool write_status_line_async (Soup.HTTPVersion http_version, uint status, string reason_phrase, int priority = GLib.Priority.DEFAULT, GLib.Cancellable? cancellable = null, out size_t bytes_written) throws GLib.Error;
		[Version (since = "0.2")]
		public virtual GLib.OutputStream body { get; }
		[Version (since = "0.3")]
		public GLib.SList<Soup.Cookie> cookies { owned get; }
		[Version (since = "0.2")]
		public bool head_written { get; }
		[Version (since = "0.1")]
		public Soup.MessageHeaders headers { get; protected set construct; }
		[Version (since = "0.3")]
		public virtual string? reason_phrase { owned get; set; }
		[Version (since = "0.1")]
		public VSGI.Request request { get; construct; }
		[Version (since = "0.1")]
		public virtual uint status { get; set; }
		[Version (since = "0.3")]
		public signal void wrote_headers (Soup.MessageHeaders headers);
		[Version (since = "0.3")]
		public signal void wrote_status_line (uint status, string reason_phrase);
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.1")]
	public abstract class Server : GLib.Object {
		public Server ();
		[Version (since = "0.3")]
		protected async bool dispatch_async (VSGI.Request req, VSGI.Response res, int priority = GLib.Priority.DEFAULT) throws GLib.Error;
		[Version (experimental = true, since = "0.3")]
		public virtual GLib.Pid fork () throws GLib.Error;
		[Version (since = "0.3")]
		public abstract void listen (GLib.SocketAddress? address = null) throws GLib.Error;
		[Version (since = "0.3")]
		public abstract void listen_socket (GLib.Socket socket) throws GLib.Error;
		[Version (since = "0.3")]
		public static new VSGI.Server? @new (string name, ...);
		[Version (since = "0.3")]
		public static new VSGI.Server? new_valist (string name, va_list list);
		[Version (since = "0.3")]
		public int run (string[] args = new string[0] { });
		[Version (since = "0.3")]
		public abstract void stop ();
		[Version (since = "0.3")]
		public VSGI.Handler handler { get; set construct; }
		[Version (since = "0.3")]
		public abstract GLib.SList<Soup.URI> uris { owned get; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class ServerModule : GLib.TypeModule {
		[Version (since = "0.3")]
		public ServerModule (string? directory, string name);
		public override bool load ();
		public override void unload ();
		[Version (since = "0.3")]
		public string? directory { get; construct; }
		[Version (since = "0.3")]
		public string name { get; construct; }
		[Version (since = "0.3")]
		public string path { get; construct; }
		[Version (since = "0.3")]
		public GLib.Type server_type { get; private set; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public abstract class SocketServer : VSGI.Server {
		public SocketServer ();
		[Version (since = "0.3")]
		protected abstract bool incoming (GLib.SocketConnection connection);
		public override void listen (GLib.SocketAddress? address = null) throws GLib.Error;
		public override void listen_socket (GLib.Socket socket) throws GLib.Error;
		public override void stop ();
		[Description (blurb = "Listen queue depth used in the listen() call")]
		[Version (since = "0.3")]
		public int backlog { get; construct; }
		[Version (since = "0.3")]
		protected abstract string scheme { get; }
		public override GLib.SList<Soup.URI> uris { owned get; }
	}
	[CCode (cheader_filename = "vsgi.h")]
	[Version (since = "0.3")]
	public class TeeOutputStream : GLib.FilterOutputStream {
		[Version (since = "0.3")]
		public TeeOutputStream (GLib.OutputStream base_stream, GLib.OutputStream tee_stream);
		public override bool close (GLib.Cancellable? cancellable = null) throws GLib.IOError;
		public override ssize_t write (uint8[] buffer, GLib.Cancellable? cancellable = null) throws GLib.IOError;
		[Version (since = "0.3")]
		public GLib.OutputStream tee_stream { get; construct; }
	}
	[CCode (cheader_filename = "vsgi.h", has_target = false)]
	[Version (since = "0.3")]
	public delegate GLib.Type HandlerInitFunc (GLib.TypeModule type_module);
	[CCode (cheader_filename = "vsgi.h", has_target = false)]
	[Version (since = "0.3")]
	public delegate GLib.Type ServerInitFunc (GLib.TypeModule module);
}
